#include <iostream>
#include <string>
#include <cstdlib>
#include "xinterpret.h"

using namespace std;

class ActionSet {
public:
    ActionSet(); // Fills out an ActionSet structure with default values
    ActionSet(istream &actionfile); // Fills out an ActionSet structure by parsing a .xwii file
    string get_name();

/* These are in public deliberately, access is needed from other functions
   for greatest efficiency */
    string name;
    string a, 
           b, 
           one, 
           two, 
           plus, 
           minus,
           up,
           down,
           left,
           right,
           home,
           flick;
};

class CC_ActionSet {
public:
	CC_ActionSet();
	CC_ActionSet(istream &actionfile);
	string get_name();
	
	string name, // wow, this is a lot of buttons
		   a,    // emulated mario64 for all!
		   b,
		   x,
		   y,
		   plus,
		   minus,
		   home,
		   d_up,
		   d_down,
		   d_left,
		   d_right,
		   l_part,
		   r_part,
		   l,
		   r,
		   zl,
		   zr,
		   ls_up,
		   ls_down,
		   ls_left,
		   ls_right,
		   rs_up,
		   rs_down,
		   rs_left,
		   rs_right;
};

enum stateType { RELEASED = 0, PRESSED, NO_CHANGE };

class InputState {
public:
    InputState(); // Fills out an InputState structure with default values
    bool a,
         b,
         one,
         two, // each bool is true if an event (press OR release) needs processing
         plus,
         minus,
         up,
         down,
         left,
         right,
         home,
         flick;

     stateType a_type,
               b_type,
               one_type,
               two_type,
               plus_type,
               minus_type,
               up_type,
               down_type,
               left_type,
               right_type,
               home_type,
               flick_type;
};

class CC_InputState {
public:
	CC_InputState();
	bool   a,
		   b,
		   x,
		   y,
		   plus,
		   minus,
		   home,
		   d_up,
		   d_down,
		   d_left,
		   d_right,
		   l_part,
		   r_part,
		   l,
		   r,
		   zl,
		   zr,
		   ls_up,
		   ls_down,
		   ls_left,
		   ls_right,
		   rs_up,
		   rs_down,
		   rs_left,
		   rs_right;
	stateType  a_type,
			   b_type,
		  	   x_type,
		       y_type,
		       plus_type,
		       minus_type,
		       home_type,
		       d_up_type,
    		   d_down_type,
    		   d_left_type,
    		   d_right_type,
    		   l_part_type,
    		   r_part_type,
    		   l_type,
    		   r_type,
	    	   zl_type,
	    	   zr_type,
	    	   ls_up_type,
	    	   ls_down_type,
	    	   ls_left_type,
	    	   ls_right_type,
	    	   rs_up_type,
	    	   rs_down_type,
	    	   rs_left_type,
	    	   rs_right_type;
};

void xwii_process_input(InputState &istate, ActionSet &actions);
void xwii_process_CC_input(CC_InputState &istate, CC_ActionSet &actions);
void execute_action(string event, stateType type); 
